#include <iostream>
#include <vector>
#include "ReUnirand/unirand.hpp"

int main() {
    ReUnirand::MarsagliaUniRng rng;

    try {
        // Initialise the generator with a seed value.
        rng.rinit(170);
    }
    catch (const std::exception& e) {
        std::cerr << "Error initialising RNG: " << e.what() << std::endl;
        return 1;
    }

    // Generate a random number and display it.
    float randomValue = rng.uni();
    std::cout << "Random Number: " << randomValue << std::endl;
    std::cout << "The result should be: 0.687533" << std::endl;

    std::cout << std::endl << "And now for 128 random numders:" << std::endl;
    // Define the size of the array.
    const int arraySize = 128;

    // Create a vector to store the 128 random numbers.
    std::vector<float> randomNumbers(arraySize);

    // Generate random numbers and store them in the vector.
    for (int i = 0; i < arraySize; ++i) {
        randomNumbers[i] = rng.uni();
    }

    // Output the random numbers.
    for (int i = 0; i < arraySize; ++i) {
        std::cout << "Random number " << i << ": " << randomNumbers[i] << std::endl;
    }

    return 0;
}
